import init, { open_invite, set_panic_hook } from "./pkg/lox_wasm.js";
init().then(() => {
  set_panic_hook();
  request_open_invite().then((token) => {
  open_invite(token);
  });
});

function request_open_invite() {
  return new Promise((fulfill, reject) => {
    loxServerRequest("").then((response) => {
      console.log("Got invitation token: " + response.invite);
      fulfill(response.invite);
      return;
    }).catch(() => {
      console.log("Error requesting open invite from Lox server");
      reject();
    });
  });
}

function loxServerRequest(data) {
  return new Promise((fulfill, reject) => {
    const xhr = new XMLHttpRequest();
    xhr.onreadystatechange = function() {
      if (xhr.DONE !== xhr.readyState) {
        return;
      }
      if (xhr.status !== 200) {
        console.log("Error. Status code: "+xhr.status);
        console.log(xhr);
        reject();
        return;
      }
      const response = JSON.parse(xhr.responseText);
      fulfill(response);
      return;
    };
    try {
       xhr.open('GET', "http://localhost:8001");
    } catch (err) {
      console.log("Error connecting to lox bridge db");
      reject();
      return;
    }
    xhr.send();
  });
}
